; Memorize e!
; Li Tao
; 9/13/01
; 1/15/01

#include "ti86asm.inc"

.org _asm_exec_ram

; Shell title
 nop
 jp Init
 .dw 0
 .dw VersionInfo

Init:
 ld hl,0
 ld (LastDigits),hl
; New guesses
Setup:
 call _runindicoff
 call _clrScrn
 call _homeup
 ld hl,VersionInfo
 call _puts
 call _newline
 ld hl,Prompt
 call _puts

; Loop for getting numbers
; bc = digit user is on
; hl = pointer to guess data
 ld bc,0
 ld hl,GuessData
GetNumberLoop:
 push hl
; Display cursor
 set curAble,(iy+curflags)
 call _getkey
 res curAble,(iy+curflags)
 pop hl
; Check keys
 cp kEE	       ; Cheat
 jp z,Cheat
 cp kF1	       ; Restore old correct value
 jp z,Restore
 cp kClear     ; Clear = Start over
 jp z,Setup
 cp kExit      ; Exit = Quit
 jp z,Quit
 cp kNext      ; More = Credits
 jp z,Info
 cp kDecPnt    ; Decimal point (treated like a digit)
 jp z,GetNumberLoopPoint

; No Del or Enter if there is no number yet
 push hl
 cp 0 ; clear c flag
 ld de,GuessData
 sbc hl,de
 pop hl
 jr z,SkipFullCommands
 cp kEnter     ; Enter = Check answer
 jp z,Enter
 cp kDel       ; Del = Backspace
 jr z,GetNumberLoopDel
 cp kLeft      ; Left arrow = Backspace
 jr z,GetNumberLoopDel
SkipFullCommands:
; Convert to binary, check for numbers
 sub k0
 cp 10
 jr nc,GetNumberLoop
; Convert to ASCII
 add a,48
 jr GetNumberLoopOK
Cheat:
 call Freebie
 jp GetNumberLoop

Freebie:
 push hl
 ld hl,DigitData
 add hl,bc
 ld a,(hl)
 pop hl
 ld (hl),a
 call _putc
 inc bc
 inc hl
 ret

Restore:
 push hl
 ld hl,(LastDigits)

 scf
 sbc hl,bc
 ld a,h
 cp 200
 pop hl
 jp nc,GetNumberLoop ; too high
 call Freebie
 jr Restore

; Delete up one column, adjusts screen
GetNumberLoopUpColumn:
 push de
 ld bc,(_curRow)
 dec bc
 ld (_curRow),bc
 pop de
 ld de,20
 jr GetNumberLoopDelBack
; Delete last digit
GetNumberLoopDel:
 push bc
; Clear spot at guess data
 ld a,Lspace
 ld (hl),a
 ld de,(_curCol)
 ld bc,(_curRow)

; Check for moving up a column
 ld a,e
 cp 0
 jr z,GetNumberLoopUpColumn
 dec de
GetNumberLoopDelBack:
; Clean up mess left by cursor and digit
 push de
 ld (_curCol),de
 ld a,(hl)
 call _putc
 call _putc
 pop de
 ld (_curRow),bc
 ld (_curCol),de
 pop bc

 dec bc
 dec hl
 jp GetNumberLoop
; Decimal point
GetNumberLoopPoint:
 ld a,Lperiod

; Digit key (0-9) or decimal point
GetNumberLoopOK:
 ld (hl),a
 call _putc
 inc bc
 inc hl
 jp GetNumberLoop

; Enter key
Enter:
 ld (hl),0
 ld (NumberDigits),bc
 call _homeup
 call _clrScrn

; Display your guess
 ld hl,YourGuess
 call _puts
 ld hl,GuessData
 ld de,DigitData
 ld c,0
; Checks for mistakes
MistakeLoop:
 ld a,(hl)
 ex de,hl
 ld b,(hl)
 ex de,hl
; Check for end of guess string
 cp 0
 jr z,DoneMistake
; Check for mistake
 cp b
 call nz,Mistake
 call _putc
 res 3,(iy+5)
 inc hl
 inc de
 jr MistakeLoop
DoneMistake:
 call _newline
 ld a,c
; Check if there was a mistake
 cp 1
 jr z,MessageWrong
; Right! Next:
 ld hl,Right
 call _puts
 ld hl,DigitData
 ld bc,(NumberDigits)
 add hl,bc
; Display next digits
 ld b,4
DoneMistakeLoop:
 ld a,(hl)
 call _putc
 inc hl
 djnz DoneMistakeLoop

; Display score
 call _newline
 ld hl,Score
 call _puts

 ld a,0

 ld hl,(NumberDigits)
 push hl
 ld (LastDigits),hl
; Display AHL
 call $4A33
 call _getkey
 pop hl

 jp Setup
MistakeMessageBack:
 call _getkey
 jp Setup
LowScore:
 ld hl,2
 ret
MessageWrong:
; Sorry, you're WRONG!
 ld hl,Wrong
 call _puts
 jr MistakeMessageBack

Quit:
 call _clrScrn
 call _homeup
 call _runindicon
 ret

Mistake:
; Set "wrong" register to 1
 ld c,1
; Invert mistakes
 set 3,(iy+5)
 ret

Info:
 call _clrScrn
; --- Memorize e! ---
 call _homeup
 set 3,(iy+5)
 ld hl,About
 call _puts
 res 3,(iy+5)
; Programmed by Li Tao
 call _newline
 ld hl,About2
 call _puts
; e-mail address
 ld bc,0
 ld (_penCol),bc
 ld bc,27
 ld (_penRow),bc
 ld hl,eMail
 call _vputs
 
; Version
 ld bc,46
 ld (_penCol),bc
 ld bc,57
 ld (_penRow),bc
 ld hl,Version
 call _vputs
 call _getkey
 jp Setup

NumberDigits:
 .db 0,0
DigitData:


 .db "2.718281828459045235360287471352662497757247093699959574966"
 .db "967627724076630353547594571382178525166427427466391932003059"
 .db "921817413596629043572900334295260595630738132328627943490763"
 .db "233829880753195251019011573834187930702154089149934884167509"
 .db "244761460668082264800168477411853742345442437107539077744992"
 .db "069551702761838606261331384583000752044933826560297606737113"
 .db "200709328709127443747047230696977209310141692836819025515108"
 .db "657463772111252389784425056953696770785449969967946864454905"
 .db "987931636889230098793127736178215424999229576351482208269895"
 .db "193668033182528869398496465105820939239829488793320362509443"
 .db "117301238197068416140397019837679320683282376464804295311802"
 .db "328782509819455815301756717361332069811250996181881593041690"
 .db "351598888519345807273866738589422879228499892086805825749279"
 .db "610484198444363463244968487560233624827041978623209002160990"
 .db "235304369941849146314093431738143640546253152096183690888707"
 .db "016768396424378140592714563549061303107208510383750510115747"
 .db "704171898610687396965521267154688957035035402123407849819334"
 .db "321068170121005627880235193033224745015853904730419957777093"
 .db "503660416997329725088687696640355570716226844716256079882651"
 .db "787134195124665201030592123667719432527867539855894489697096"
 .db "409754591856956380236370162112047742722836489613422516445078"
 .db "182442352948636372141740238893441247963574370263755294448337"
 .db "998016125492278509257782562092622648326277933386566481627725"
 .db "164019105900491644998289315056604725802778631864155195653244"
 .db "258698294695930801915298721172556347546396447910145904090586"
 .db "298496791287406870504895858671747985466775757320568128845920"
 .db "541334053922000113786300945560688166740016984205580403363795"
 .db "376452030402432256613527836951177883863874439662532249850654"
 .db "995886234281899707733276171783928034946501434558897071942586"
 .db "398772754710962953741521115136835062752602326484728703920764"
 .db "310059584116612054529703023647254929666938115137322753645098"
 .db "889031360205724817658511806303644281231496550704751025446501"
 .db "172721155519486685080036853228183152196003735625279449515828"
 .db "418829478761085263981395599006737648292244375287184624578036",0
About:
 .db " --- Memorize e --- ",0
About2:
 .db "Programmed by Li Tao",0
eMail:
 .db "e-mail: ltao@delta.fullerton.edu",0
Version:
 .db "Version 1.2",0
LastDigits:
 .dw 0
VersionInfo:
 .db "Memorize e! v1.2",0
YourGuess:
 .db "Your guess: ",0
Wrong:
 .db "Sorry, you're WRONG!",0
Right:
 .db "Right! Next: ",0
Score:
 .db "Score: ",0
Prompt:
 .db "e=",0

GuessData:
; Blank memory
 .db 0

.end
